<?php

##########################################################################################
# In order to be able to use this script you need to join the merchant program depending on the country where your store is selling the products
#
# Once you join the program and your application is approved you need to place the file on your server and set up the path to the file on the Merchant Interface
#
# virtuemart price options - taxes = on,off (default = on); storetaxes = on,off (default = on); discount = on,off (default = on)
# _virtuemart.php?storetaxes=off
# _virtuemart.php?taxes=off
# _virtuemart.php?discount=off
# _virtuemart.php?taxes=off&storetaxes=off&discount=off
# _virtuemart.php?add_vat=on
#
# General options
# description = on,off
# image = on,off
# sef = on,off
#
##########################################################################################



set_time_limit(0);
ignore_user_abort();
error_reporting(E_ALL ^ E_NOTICE);
$_SVR = array();

# You need to do place this file in your root directory, where the configuration file is located.
# Otherwise, if you place this file in another directory please modify the line below with the path to the directory where the configuration file is located.
# In this case, $absolute_path_config should contain the path that is found in $mosConfig_absolute_path variable from the configuration.php file, followed by / 
$absolute_path_config = "./";

# Once all is set up you need to check the result and make sure the output is correct
# Point the browser to http://www.example.com/path_to_datafeed/virtuemart.php and look into the source code of the out put
# What you need to see is something like this
# Category | Manufacturer | Part Number | Merchant Code | Product Name | Product Description | Product URL | Product Image URL | Product Price | Currency 

##### Avoid any modifications below this line #####

// Include configuration file
if(!file_exists($absolute_path_config . "configuration.php")) {
	exit('<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>Not Found</H1>Please ensure that the virtuemart php script is in the root directory, or make sure the path to the directory where the configuration file is located is defined corectly above in $absolute_path_config variable</BODY></HTML>');
}
else {
	require_once($absolute_path_config . "configuration.php");
}

// Used for compatibility with Joomla 1.5
if (file_exists($absolute_path_config . 'administrator/components/com_virtuemart/compat.joomla1.5.php')) {
	define( '_VALID_MOS', 1 );
	define( '_JEXEC', 1 );
	include_once($absolute_path_config . 'administrator/components/com_virtuemart/compat.joomla1.5.php' );
	include_once('administrator/components/com_virtuemart/virtuemart.cfg.php');
	include_once('administrator/components/com_virtuemart/classes/shipping/flex.cfg.php');	
	
}

// Datafeed specific settings
$datafeed_separator = "|"; // Possible options are \t or |

// Force datafeed currency - leave this empty in order to use the currency setted up in the database or change it in order to force a different currency
$use_currency = ""; // ex. USD
// Force image path - change this value with the path to your files  or leave empty in order to use store settings
$use_imagepath = ""; // ex. http://www.mysite.com/images/

// Define VAT value
$vat_value = 1.20; // 20%

$already_sent = array();
// Taxes options - possible values on, off
$applytaxes = ($_GET['taxes'] == "off") ? "off" : "on";
// Store taxes options - possible values on, off
$applystoretaxes = ($_GET['storetaxes'] == "off") ? "off" : "on";
// Discount options - possible values on, off
$applydiscount = ($_GET['discount'] == "off") ? "off" : "on";
// Add VAT to prices
$add_vat = ($_GET['add_vat'] == "on") ? "on" : "off";
// SEF options - possible values on, off
$sef = ($_GET['sef'] == "on") ? "on" : "off";
// Description options - possible values on, off
$show_description = ($_GET['description'] == "off") ? "off" : "on";
// Image options - possible values on, off
$show_image = ($_GET['image'] == "off") ? "off" : "on";
// Short description options - possible values on, off
$show_short_description = ($_GET['short_description'] == "on") ? "on" : "off";



// Connect to the database
$conn = @mysql_connect($mosConfig_host, $mosConfig_user, $mosConfig_password);
if (mysql_error()) {
	print "<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>Not Found</H1>Connection error. Please check the connection settings. Bye bye...</BODY></HTML>";
	exit;
}
else {
	@mysql_select_db($mosConfig_db, $conn);
	if (mysql_error()) {
		print "<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>Not Found</H1>Connection error. Please check the connection settings. Bye bye...</BODY></HTML>";
		exit;
	}
}

// Tables variables
$prod_table = $mosConfig_dbprefix . "vm_product"; // products table
$cat_table = $mosConfig_dbprefix . "vm_category"; // categories table
$cat_xref_table = $mosConfig_dbprefix . "vm_category_xref"; // categories xref table
$manuf_table = $mosConfig_dbprefix . "vm_manufacturer"; // manufacturer table
$price_table = $mosConfig_dbprefix . "vm_product_price"; // product price table
$manuf_xref_table = $mosConfig_dbprefix . "vm_product_mf_xref"; // product manufacturer xref table
$prod_cat_xref_table = $mosConfig_dbprefix . "vm_product_category_xref"; // product category xref table
$tax_rate_table = $mosConfig_dbprefix . "vm_tax_rate"; // tax rate table
$vendor_table = $mosConfig_dbprefix . "vm_vendor"; // vendor table
$discount_table = $mosConfig_dbprefix . "vm_product_discount"; // vendor table
//$group_table = $mosConfig_dbprefix . "jos_vm_shopper_group"; // gruppi utenti

// Shopper group options - possible values on, off
$use_shoppergroup = ($_GET['shoppergroup'] == "on") ? "on" : "off";
if ($use_shoppergroup == "on") 
{
	// Get default shopper group 
	$q = "SELECT * FROM " . $mosConfig_dbprefix . "vm_shopper_group WHERE " . $mosConfig_dbprefix . "vm_shopper_group.default = 1";
	$r = @mysql_query($q);
	if (!mysql_error())
  {
		while ($field = mysql_fetch_assoc($r)) 
    {
			$SHOPPER_GROUP = $field;
		}
	}
	$shopper_group_id = (@$SHOPPER_GROUP['shopper_group_id'] > 0) ? $SHOPPER_GROUP['shopper_group_id'] : "";
	$add_shopper_group_cond = ($shopper_group_id > 0) ? " AND shopper_group_id = '" . $shopper_group_id . "'" : "";
}
else
{
	$add_shopper_group_cond = "";
}



// Get the store's tax rate
$q = "SELECT tax_rate FROM $vendor_table, $tax_rate_table WHERE tax_country=vendor_country AND $vendor_table.vendor_id='1' ORDER BY tax_rate DESC LIMIT 0,1";
/*$r = @mysql_query($q);
if (!mysql_error()) {
	while ($field = mysql_fetch_assoc($r)) {
		$rate = $field['tax_rate'];
	}
}             */



   if($r = mysql_query($q) )
   {
   	while ($field = mysql_fetch_assoc($r)) {
		$rate = $field['tax_rate'];

		}
	}
   else
   {

	   echo "Errore nell'esecuzione della query:<br>".$q."<br>".mysql_errno().": ".mysql_error()."<br>";
   }


// Get all categories
$q_cat ="SELECT $cat_table.category_id, $cat_table.category_name, $cat_xref_table.category_parent_id as parent_id, $cat_table.category_flypage
FROM $cat_table LEFT JOIN $cat_xref_table ON ( $cat_table.category_id = $cat_xref_table.category_child_id )";
//$res_cat = @mysql_query($q_cat);
/*if (!mysql_error())
{
	while ($field = mysql_fetch_assoc($res_cat)) 
  {
		$CAT_ARR[$field['category_id']] = $field;
	}
}   */

   if($res_cat = mysql_query($q_cat) )
   {
   	while ($field = mysql_fetch_assoc($res_cat)) {
       $CAT_ARR[$field['category_id']] = $field;
		}
	}
   else
   {

	   echo "Errore nell'esecuzione della query:<br>".$q_cat."<br>".mysql_errno().": ".mysql_error()."<br>";
   }



// Query database for extracting data. It might be needed to left join the categories table for extracting the category name
$image_field = ($show_image == "on") ? "$prod_table.product_full_image" : "''";
$long_description = "$prod_table.product_desc";
$short_description = "$prod_table.product_s_desc";
$description_field = ($show_short_description == "on") ? $short_description :  $long_description;
$description_field = ($show_description == "on") ? $description_field :  "''";
//$description_field = ($show_description == "on") ? "$prod_table.product_desc" : "''";

$q = "SELECT
$cat_table.category_id,
$manuf_table.mf_name, 
$prod_table.product_sku, 
$prod_table.product_id,
$prod_table.product_name,
$prod_table.product_special,
" . $description_field . ", 
" . $image_field . ", 
$price_table.product_price,
$price_table.product_currency, 
$price_table.shopper_group_id, 
$prod_table.product_weight, 
$tax_rate_table.tax_rate, 
$discount_table.amount, 
$discount_table.is_percent, 
$discount_table.start_date, 
$discount_table.end_date,
$prod_table.product_in_stock

FROM $prod_table
LEFT JOIN $prod_cat_xref_table ON $prod_table.product_id = $prod_cat_xref_table.product_id
LEFT JOIN $cat_table ON $prod_cat_xref_table.category_id = $cat_table.category_id
LEFT JOIN $manuf_xref_table ON $prod_table.product_id = $manuf_xref_table.product_id
LEFT JOIN $manuf_table ON $manuf_xref_table.manufacturer_id = $manuf_table.manufacturer_id
LEFT JOIN $price_table ON ($prod_table.product_id = $price_table.product_id " . $add_shopper_group_cond . ")
LEFT JOIN $tax_rate_table ON $prod_table.product_tax_id = $tax_rate_table.tax_rate_id
LEFT JOIN $discount_table ON $prod_table.product_discount_id = $discount_table.discount_id
WHERE $prod_table.product_publish = 'Y' AND $prod_table.product_parent_id = 0
GROUP BY $prod_table.product_id
ORDER BY $cat_table.category_id DESC";

  /*if (isset($_GET['group_id']))
  {
  $group_id = $_GET['group_id'];
  $q += " AND $price_table.shopper_group_id = $group_id";
  }  */

 $shipping_modes = $PSHOP_SHIPPING_MODULES;
 $shipping_modes_avaiable = getshippingmodesAvaiable($shipping_modes);
 $shippingdetails =  getshippingsdetails($shipping_modes_avaiable);

   if (DebugIsEnable())
   {
       echo "Metodi di spedizione merchant: ".implode(', ', $shipping_modes)."</br>";

       echo "Metodi di spedizione attivi per  il merchant: ".implode(', ', $shipping_modes_avaiable)."</br>";


   }

  // $shipping_modes_avaiable = getshippingmodesAvaiable($shipping_modes);
  // $shippingdetails =  getshippingsdetails($shipping_modes_avaiable);




   if($r = mysql_query($q) )
   {
	// Print the header
   	echo "Product_Code|Product_Name|Manufacturer|Model|Product_Description|ProductURL|ImageURL|Category_Id|Category_Name|Product_Price|Product_Currency|Product_in_stock<FINERIGA>";
   		
   	while (list(
         $cat_id, 
         $prod_manufacturer,
         $prod_model, 
         $prod_id,
         $prod_name,
         $prod_special,
         $prod_desc,
         $prod_image, 
         $prod_price,
         $prod_currency, 
         $shopper_group_id,
         $product_weight, 
         $tax_rate,
         $discount_amount, 
         $discount_is_percent,
         $discount_start_date, 
         $discount_end_date,
         $product_in_stock) = mysql_fetch_row($r))
     {

     if (DebugIsEnable())
   	{

         echo '<p>Prodotto speciale:' . $prod_special.'  '.'Prezzo prodotto:'.$prod_price .'  '.'Sconto percentuale: '. $discount_is_percent.'  '.'Sconto fisso: '. $discount_amount.'  '.'Data inizio validit sconto: '. $discount_start_date.'  '.'Data fine validit sconto: '. $discount_end_date. '  '.'Tasse negozio: '. $rate. '  ' .'Tasse : '.$tax_rate . '   ' . 'IVA: '. $vat_value . "</p>";	
      }
   		// If we've sent this one, skip the rest - this is to ensure that we do not get duplicate products
   		if ($already_sent[$prod_id] == 1) continue;
   		
   		// Get price
   		if ($tax_rate != NULL)
   		{
   			if ($applytaxes == "on")
   			{
   				$prod_price *= ($tax_rate + 1);
   			}
   		}
   		elseif ($rate > 0)
   		{
   			// if we didn't find a product tax rate id, let's use the store's tax rate
   			if ($applystoretaxes == "on")
   			{
   				$prod_price *= ($rate + 1);
   			}
   		}	
   		$prod_price = round( $prod_price, 2 );
   		
   		// Apply product discount
   		//date_default_timezone_set('Antarctica/Casey');
   	 // date_default_timezone_set('Europe/Madrid');

        $script_tz = date_default_timezone_get();



        if (DebugIsEnable())
   		{

           if (strcmp($script_tz, ini_get('date.timezone')))
           {
           $script_tz =  ini_get('date.timezone');
           echo '<p>Script timezone differs from ini-set timezone.The timezone  in php.ini is: '.$script_tz. "</p>";
           }
           else
           {
           echo '<p>Script timezone and ini-set timezone match. The timezone is: '. $script_tz. "</p>";
           }

   		}
   		
   		$now_date_time = mktime(date("G"),date("i"),date("s"),date("n"),date("j"),date("Y"));
   		if ($applydiscount == "on" && $discount_amount > 0 && (($discount_start_date < $now_date_time || $discount_start_date == 0) && ($now_date_time < $discount_end_date || $discount_end_date == 0)))
   		{
   			if ($discount_is_percent > 0)
   			{
   				$prod_price -= ($prod_price * $discount_amount) / 100;
   			}
   			else
   			{
   				$prod_price -= $discount_amount;
   			}
   		}
   		$prod_price = round( $prod_price, 2 );
   		
   		// Clean product name (new lines)
   		$prod_name = str_replace("\n", "", strip_tags($prod_name));
   		$prod_name = str_replace("\r", "", strip_tags($prod_name));
   		$prod_name = str_replace("\t", " ", strip_tags($prod_name));
   		
   		// Clean product description (Replace new line with <BR>). In order to make sure the code does not contains other HTML code it might be a good ideea to strip_tags()
   		//$prod_desc = clean_description($prod_desc);
       $prod_desc = replace_not_in_tags("\n", "<BR />", $prod_desc);
   		$prod_desc = str_replace("\n", " ", $prod_desc);		
   		$prod_desc = str_replace("\r", " ", $prod_desc);
   		$prod_desc = str_replace("\t", " ", $prod_desc);
   		$prod_desc = CleanHtml($prod_desc);
   		
   		// Clean product names and descriptions (separators)
   		if ($datafeed_separator == "\t")
       {
   			// Continue... tabs were already removed
   		}
   		elseif ($datafeed_separator == "|")
       {
   			$prod_name = str_replace($datafeed_separator, " ", strip_tags($prod_name));
   			$prod_desc = str_replace($datafeed_separator, " ", $prod_desc);
   		}
   		else
       {
   			print "Incorrect columns separator.";
   			exit;		
   		}

   			
   		// Get all category id
   		$category_ids = getCategoryIds($prod_cat_xref_table, $cat_xref_table, $cat_table, $prod_id);      		
   		$category_ids = implode(";",$category_ids);
   		
   		if (DebugIsEnable())
   		{
   		  //$category_ids2 = getCategoryIds($prod_cat_xref_table, $cat_xref_table, $cat_table, $prod_id);
   		  echo "<p><b>Product [" . $prod_id . "] - category id list :</b>" . $category_ids . "</p>";
         }
   		
   		// Get all category name
   		//$category_name = get_full_cat($cat_id, $CAT_ARR);		
   		$category_names = getCategoryNames($prod_cat_xref_table, $cat_xref_table, $cat_table, $prod_id);
   		$category_names = implode(" ",$category_names);
   		
   		$category_flypage = ($CAT_ARR[$cat_id]['category_flypage'] != "") ? $CAT_ARR[$cat_id]['category_flypage'] : "shop.flypage";
   		
   		if ($sef == "on")
   		{
   			$prod_url = function_to_get_sef_url($prod_id, $prod_name, $cat_id, $CAT_ARR);
   		}
   		else
   		{
   			$prod_url = function_to_get_product_url($prod_id, $cat_id, $category_flypage);	
   		}
   		
   		if ($use_imagepath != "")
   		{
   			$prod_image = ($prod_image != "") ? $use_imagepath . $prod_image : "";
   			$prod_image = str_replace("/administrator","",$prod_image);
   			//$prod_image = str_replace("/joomla","",$prod_image);
   		}
   		else
   		{
   			$prod_image = ($prod_image != "") ? function_to_get_product_image($prod_image) : "";
   			$prod_image = str_replace("/administrator","",$prod_image);
   			//$prod_image = str_replace("/joomla","",$prod_image);
   		}
   		
   		// Add VAT to prices
   		if ($add_vat == "on")
   		{
   			$prod_price = $prod_price * $vat_value;
   		}
   		
   		if ($use_currency != "")
       {
   			$prod_currency = $use_currency;
   		}
   		
   		#### CURRENCY EXCHANGE RATES _ NOT TESTED###############
   		/*
   		if( !$currA ) {
   			$currA = $prod_currency;
   		}
   		if( !$currB ) {
   			$currB = $GLOBALS['product_currency'];
   		}
   		// If both currency codes match, do nothing
   		if( $currA == $currB ) {		
   			// Continue
   		}
   		else {
   			$valA = isset( $GLOBALS['converter_array'][$currA] ) ? $GLOBALS['converter_array'][$currA] : 1;
   			$valB = isset( $GLOBALS['converter_array'][$currB] ) ? $GLOBALS['converter_array'][$currB] : 1;
   		
   			$prod_price = $prod_price * $valB / $valA;
   			$prod_currency = isset( $GLOBALS['product_currency'] ) ? $GLOBALS['product_currency'] : $prod_currency;
   		}
   		*/
   		################################################
   				
       // Output the datafeed content
   		// ProdCode, ProdName, Manufacturer, Model , ProdDescription, ProdURL, ImageURL, Category ids, Category names, Price, Currency, Product in stock
   		echo
   			$prod_id . $datafeed_separator .
   			$prod_name . $datafeed_separator .
         $prod_manufacturer . $datafeed_separator .
   			$prod_model . $datafeed_separator .			
   			$prod_desc . $datafeed_separator .
   			$prod_url . $datafeed_separator .
   			$prod_image . $datafeed_separator .
   			$category_ids . $datafeed_separator . 
         $category_names . $datafeed_separator .
         $prod_price . $datafeed_separator .
   			$prod_currency . $datafeed_separator . 
   			$product_in_stock . "<FINERIGA>";
   		
   		$already_sent[$prod_id] = 1;
   	}
	}
   else
   {

	   echo "Errore nell'esecuzione della query:<br>".$q."<br>".mysql_errno().": ".mysql_error()."<br>";
   }



// Function to return the Product URL based on your product ID - ADDING KELKOO PARAMETER
function function_to_get_product_url($prod_id, $cat_id, $flypage)
{
	global $mosConfig_live_site;
	
    //$new_mosConfig_live_site = str_replace("/joomla","",$mosConfig_live_site);
   $new_mosConfig_live_site = str_replace("/administrator","",$mosConfig_live_site);
   return $new_mosConfig_live_site . "/index.php?page=shop.product_details&flypage=" . $flypage . "&product_id=" . $prod_id . "&category_id=" . $cat_id . "&option=com_virtuemart&from=kelkoo";


	//return $mosConfig_live_site . "/index.php?page=shop.product_details&flypage=" . $flypage . "&product_id=" . $prod_id . "&category_id=" . $cat_id . "&option=com_virtuemart";
}

// Function to return the Product URL based on your product ID
function function_to_get_sef_url($prod_id, $prod_name, $cat_id, $CATEGORY_ARR)
{
	global $mosConfig_live_site;
	
	$item_arr = $CATEGORY_ARR[$cat_id];
	$cat_str_key = build_str_key(html_to_text($item_arr['category_name']));
	
	while (sizeof($CATEGORY_ARR[$item_arr['parent_id']]) > 0 && is_array($CATEGORY_ARR[$item_arr['parent_id']]) ) 
	{		
		$cat_str_key = build_str_key(html_to_text($CATEGORY_ARR[$item_arr['parent_id']]['category_name'])) . "/" . $cat_str_key;	
		$item_arr = $CATEGORY_ARR[$item_arr['parent_id']];
	}
	
	$prod_str_key = build_str_key($prod_name);
	
	return $mosConfig_live_site . "/" . $cat_str_key . "/" . $prod_str_key . "/";
}

// Function to return the Product Image based on your product image or optionally Product ID
function function_to_get_product_image($prod_image)
{
	global $mosConfig_live_site;
	
	if ($prod_image == "") {
		return false;
	}
	else {
	
		if (preg_match("/http\:\/\//", $prod_image)) {
		
		return $prod_image;
		}
		else {

			return $mosConfig_live_site . "/components/com_virtuemart/shop_image/product/" . $prod_image;
		}
	}
}

//Function to get all category id for one product.
function getCategoryIds($prod_cat_xref_table, $cat_xref_table, $cat_table, $prod_id)
{
  // Get all categories
  $query = "SELECT $cat_table.category_id, $cat_table.category_name, $cat_xref_table.category_parent_id as parent_id
  FROM $cat_table
  LEFT JOIN $cat_xref_table ON ( $cat_table.category_id = $cat_xref_table.category_child_id )
  LEFT JOIN $prod_cat_xref_table ON ( $cat_table.category_id = $prod_cat_xref_table.category_id )
  WHERE $prod_cat_xref_table.product_id = $prod_id
  ORDER BY $cat_table.category_id";
                                                   
  $result = @mysql_query($query);
  
  if (!mysql_error()) 
  {
    $category_ids = array();
  	while ($field = mysql_fetch_row($result)) 
    {
  		array_push($category_ids, $field[0]);
  		
  		if ( ($field[2] != '0') && !(in_array($field[2], $category_ids)))
  		{
  		  array_push($category_ids, $field[2]);  
      }
  	}       
    
    sort($category_ids, SORT_NUMERIC);
          	
  	return $category_ids;
  }
  else
  {
    print "<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>Not Found</H1>Query error: " . mysql_error() . "</BODY></HTML>";
  }
}


//Function to get all category name for one product.
function getCategoryNames($prod_cat_xref_table, $cat_xref_table, $cat_table, $prod_id)
{
  $query = "select $cat_table.category_name, $cat_table.category_id, $cat_xref_table.category_parent_id as parent_id 
  from $cat_table
  LEFT JOIN $cat_xref_table ON ( $cat_table.category_id = $cat_xref_table.category_child_id )
  LEFT JOIN $prod_cat_xref_table ON $cat_table.category_id = $prod_cat_xref_table.category_id
  WHERE $prod_cat_xref_table.product_id = $prod_id 
  ORDER BY $cat_table.category_id";
  
  $result = @mysql_query($query);
  
  if (!mysql_error()) 
  {
    $category_names = array();
  	while ($field = mysql_fetch_row($result)) 
    {
      if ( ($field[2] != '0'))
  		{ 
        $result2 = @mysql_query("select $cat_table.category_name from $cat_table where $cat_table.category_id = $field[2]");  		  
  		  $field2 = mysql_fetch_row($result2);
  		  
        $category_parent_name = $field2[0];
  		  if (!(in_array($category_parent_name, $category_names)))
  		  {
  		    array_push($category_names, $category_parent_name);  
        }
      }
      
      if (!(in_array($field[0], $category_names)))
  		{
        array_push($category_names, $field[0]);
      }  		
  	}           
                        	
  	return $category_names;
  }
  else
  {
    print "<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>Not Found</H1>Query error: " . mysql_error() . "</BODY></HTML>";
  }
}

// Function to get category with full path
function get_full_cat($cat_id, $CATEGORY_ARR) 
{

	$item_arr = $CATEGORY_ARR[$cat_id];
	$cat_name = $item_arr['category_name'];
	
	while (sizeof($CATEGORY_ARR[$item_arr['parent_id']]) > 0 && is_array($CATEGORY_ARR[$item_arr['parent_id']]) ) 
  {
		
		$cat_name = $CATEGORY_ARR[$item_arr['parent_id']]['category_name'] . "-" . $cat_name;		
		$item_arr = $CATEGORY_ARR[$item_arr['parent_id']];
	}
	
	// Strip html from category name
	$cat_name = html_to_text($cat_name);
	
	return $cat_name;
}

function html_to_text($string)
{

	$search = array (
		"'<script[^>]*?>.*?</script>'si",  // Strip out javascript
		"'<[\/\!]*?[^<>]*?>'si",  // Strip out html tags
		"'([\r\n])[\s]+'",  // Strip out white space
		"'&(quot|#34);'i",  // Replace html entities
		"'&(amp|#38);'i",
		"'&(lt|#60);'i",
		"'&(gt|#62);'i",
		"'&(nbsp|#160);'i",
		"'&(iexcl|#161);'i",
		"'&(cent|#162);'i",
		"'&(pound|#163);'i",
		"'&(copy|#169);'i",
		"'&(reg|#174);'i",
		"'&#8482;'i",
		"'&#149;'i",
		"'&#151;'i",
		"'&#(\d+);'e"
		);  // evaluate as php
	
	$replace = array (
		" ",
		" ",
		"\\1",
		"\"",
		"&",
		"<",
		">",
		" ",
		"&iexcl;",
		"&cent;",
		"&pound;",
		"&copy;",
		"&reg;",
		"<sup><small>TM</small></sup>",
		"&bull;",
		"-",
		"uchr(\\1)"
		);
	
	$text = preg_replace ($search, $replace, $string);
	return $text;	
}

function clean_description($string)
{

	$search = array (
		"'<html>'i",
		"'</html>'i",
		"'<body>'i",
		"'</body>'i",
		"'<head>.*?</head>'si",
		"'<!DOCTYPE[^>]*?>'si"
		); 
		
	$replace = array (
		"",
		"",
		"",
		"",
		"",
		""
		); 
		
	$text = preg_replace ($search, $replace, $string);
	return $text;

}

function build_str_key($text)
{
	
	$text = str_replace(" ", "-", trim(string_clean_search($text)));
	$text = rawurlencode(strtolower($text));
	
	$text = strtolower(clean_accents($text));
	
	return $text;
}

function clean_accents($text)
{

	$search = array (
		
		"'%C4%99'", #e
		"'%C3%A8'", #e
		"'%C3%A9'", #e
		"'%C3%AA'", #e
		"'%C3%AB'", #e
		"'%C3%89'", #e
		"'%C3%88'", #E
		"'%C3%8A'", #E
		
		"'%C4%85'", #a
		"'%C3%A3'", #a
		"'%C3%A0'", #a
		"'%C3%A4'", #a
		"'%C3%A2'", #a	
		"'%C3%A1'", #a
		"'%C3%A5'", #a
		"'%C3%81'", #A
		"'%C3%82'", #A
		"'%C3%84'", #A
		"'%C3%85'", #A
		"'%C3%80'", #A
		
		"'%C4%87'", #c
		"'%C3%A7'", #c
		"'%C3%87'", #C
		
		"'%C5%9B'", #s
		"'%C5%A1'", #s
		"'%C5%A0'", #S
		"'%C5%9A'", #S
		
		"'%C3%B0'", #d
		"'%C3%B1'", #n
		"'%C3%BD'", #y
		"'%C4%9F'", #g
		
		"'%C4%B1'", #i
		"'%C3%AE'", #i
		"'%C3%AD'", #i
		"'%C3%AF'", #i
		"'%C3%AC'", #i
		"'%C3%8D'", #I
		"'%C3%8E'", #I
		"'%C4%B0'", #I
		
		"'%C5%82'", #l
		
		"'%C5%84'", #n
		
		"'%C3%BA'", #u
		"'%C3%BB'", #u
		"'%C3%B9'", #u
		"'%C3%BC'", #u
		"'%C5%B1'", #u
		
		"'%C3%9C'", #U
		
		"'%C3%B4'", #o
		"'%C3%B3'", #o
		"'%C3%91'", #o
		"'%C3%B6'", #o
		"'%C5%91'", #o
		"'%C3%B2'", #o
		"'%C3%B5'", #o
		"'%C3%93'", #O
		"'%C3%96'", #O
		
		"'%C3%9F'", #ss
		"'%C5%BC'", #z
		"'%C5%BA'", #z
		"'%C5%BB'", #Z
		
		"'%C3%A6'", #ae
		"'%C3%B8'", #oe
		
		"'%C2%AE'",
		"'%C2%B4'",
		"'%E2%84%A2'",
		
	);
	
	$replace = array (
		
		"e",
		"e",
		"e",
		"e",
		"e",
		"e",
		"E",
		"E",
		
		"a",
		"a",
		"a",
		"a",
		"a",
		"a",
		"a",
		"A",
		"A",
		"A",
		"A",
		"A",
		
		"c",
		"c",
		"C",
		
		"s",
		"s",
		"S",
		"S",
		
		"d",
		"n",
		"y",
		"g",
		
		"i",
		"i",
		"i",
		"i",
		"i",
		"I",
		"I",
		"I",
		
		"l",
		
		"n",
		
		"u",
		"u",
		"u",
		"u",
		"u",
		
		"U",
		
		"o",
		"o",
		"o",
		"o",
		"o",
		"o",
		"o",
		"O",
		"O",
		
		"ss",
		"z",
		"z",
		"Z",
		
		"ae",
		"oe",
		
		"",
		"",
		"",
		
	);
	
	$text = preg_replace($search, $replace, $text);
	
	return $text;

}

// CLEANS STRINGS
function string_clean_search($string){
	
	$trans = get_html_translation_table(HTML_ENTITIES);
	$trans = array_flip ($trans);
	$string = strtr($string, $trans);
	
	$search = array (
		"'&quot;'",
		"'&lt;'",
		"'&gt;'",
		"'%&pound;'",
		"'%&euro;'",
		"'-'",
		"'~'",
		"'!'",
		"'\?'",
		"'@'",
		"'#'",
		"'\\$'",
		"'%'",
		"'\^'",
		"'&'",
		"'\*'",
		"'\('",
		"'\)'",
		"'_'",
		"'\+'",
		"'='",
		"'\.'",
		"','",
		"'\''",
		"'\['",
		"'\]'",
		"'{'",
		"'}'",
		"'\|'",
		"'\"'",
		"':'",
		"';'",
		"'/'",
		"'\\\'",
		"'>'",
		"'<'",		
		"'[\r]+'",
		"'[\n]+'",
		"'[\t]+'",
		"'[\s]+'",
	);
	
	$replace = array (
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
	);
	
	$string = preg_replace($search, $replace, $string);
	
	return $string;
	
}

function replace_not_in_tags($find_str, $replace_str, $string) {
	
	$find = array($find_str);
	$replace = array($replace_str);	
	preg_match_all('#[^>]+(?=<)|[^>]+$#', $string, $matches, PREG_SET_ORDER);	
	foreach ($matches as $val) {	
		if (trim($val[0]) != "") {
			$string = str_replace($val[0], str_replace($find, $replace, $val[0]), $string);
		}
	}	
	return $string;
}

function print_array($arr) {
	
	echo "<pre>";
	print_r($arr);
	echo "</pre>";	
}

function CleanHtml($prod_desc)
{
  $prod_desc = strip_tags($prod_desc);                    //elimina i tags html
  $prod_desc = substr($prod_desc,0,255);               //taglia la stringa fino a max 255 caratteri     
  $search = array ("'<script[^>]*?>.*?</script>'si",   // Rimozione del javascript
               "'<[\/\!]*?[^<>]*?>'si",           // Rimozione dei tag HTML
                     "'([\r\n])[\s]+'",                  // Rimozione degli spazi bianchi
                  "'([\r])+'",                         // Rimozione degli spazi bianchi
                  "'([\n])+'",                      // Rimozione degli spazi bianchi
                     "'&(quot|#34);'i",                   // Sostituzione delle entit HTML
                     "'&(amp|#38);'i",
                     "'&(lt|#60);'i",
                   "'&(gt|#62);'i",
                 "'&(nbsp|#160);'i",
                  "'&(iexcl|#161);'i",
                  "'&(cent|#162);'i",
                  "'&(pound|#163);'i",
                  "'&(copy|#169);'i",
                  "'&#(\d+);'e");                      // Valuta come codice PHP

  $replace = array ("",
             "",
             "",
         "",
           "",
             "",
             "",
             "",
             "",
             "",
             chr(161),
             chr(162),
             chr(163),
             chr(169),
             "chr(\\1)");

  $description = preg_replace($search, $replace, $prod_desc);
  return $description;
}

   function DebugIsEnable()
   {
    if (isset($_GET['debug']))
    {
	   if($_GET['debug']=="debugme") 
	   {
	       return true;
	   }
    }
    return false;
   }

   function getshippingmodesAvaiable($merchant_shipping_modes)
   {


      $metodi_attivi = array();
     foreach ($merchant_shipping_modes as $metodo){


        // Calcolo le spese di spedizione in base ai metodi installati
          switch ($metodo){

            case "flex" :       // Spese di spedizione flat

               if (DebugIsEnable())
        		   {
        		      echo "Il metodo flex.php  gestito"."</p>";
        		   }
        		   array_push($metodi_attivi,"flex");

               /*  $activesql = "SELECT configuration_value FROM ".TABLE_CONFIGURATION." WHERE configuration_key=\"MODULE_SHIPPING_FLAT_STATUS\"";
                 if($res = mysql_query($activesql, $link ) ){
                    $row = mysql_fetch_row($res);
                    if ($row[0] == "True"){
                       array_push($metodiattivi,"flat");
                    }
                 } */
               break;

            case "standard_shipping" :
               if (DebugIsEnable())
        		   {
        		      echo "Il metodo standard_shipping.php  gestito"."</p>";
        		   }
        		   array_push($metodi_attivi,"standard_shipping");

               break;

            default :
               if (DebugIsEnable())
        		   {
        		      echo "Il metodo ".$metodo." non  gestito"."</p>";
        		   }

                      // Spese di spedizione calcolate con un modulo custom
               //array_push($metodiattivi,"custom");
            }


        }
        return $metodi_attivi;

   }

   function getshippingsdetails($shippingmodes){

      $details = array();

      foreach ($shippingmodes as $metodo){
         switch ($metodo){

         case "flex" :     //Spese di spedizione flat
            $details["flex"]["base_amount"]  = FLEX_BASE_AMOUNT;
            $details["flex"]["min_chg"]  = FLEX_MIN_CHG;
            $details["flex"]["ship_perc"]  = FLEX_SHIP_PERC;
            $details["flex"]["tax_class"]  = FLEX_TAX_CLASS;
            $details["flex"]["hand_fee"]  = FLEX_HAND_FEE;

            //$base_amount = FLEX_BASE_AMOUNT;

           // $handlingsql = "SELECT configuration_VALUE FROM ".TABLE_CONFIGURATION." WHERE configuration_key=\"MODULE_SHIPPING_FLAT_HANDLING\"";

          /*  if($res = mysql_query($costsql, $link ) ){
               $row = mysql_fetch_row($res);
               $details["flex"]["base_amount"] = $row[0];
            }
            if($res = mysql_query($handlingsql, $link ) ){
               $row = mysql_fetch_row($res);
               $shippingdetails["flat"]["handling"] = $row[0];
            }   */
            break;

         case "standard_shipping" :

     /* $q = "SELECT shipping_carrier_id,shipping_carrier_name FROM #__{vm}_shipping_carrier ORDER BY shipping_carrier_list_order ASC" ;
		$dbc->query( $q ) ;
		$i = 0 ;
		$html = "" ;
		while( $dbc->next_record() ) {
			$q = "SELECT shipping_rate_id,shipping_rate_name,shipping_rate_value,shipping_rate_package_fee FROM #__{vm}_shipping_rate WHERE " ;
			$q .= "shipping_rate_carrier_id='" . $dbc->f( "shipping_carrier_id" ) . "' AND " ;
			$q .= "(shipping_rate_country LIKE '%" . $country . "%' OR " ;
			$q .= "shipping_rate_country = '') AND " ;
			if( is_numeric( $zip ) ) {
				$q .= "(shipping_rate_zip_start <= '" . $zip . "' OR  LENGTH(shipping_rate_zip_start) = 0 ) AND " ;
				$q .= "(shipping_rate_zip_end >= '" . $zip . "' OR  LENGTH(shipping_rate_zip_end) = 0 ) AND " ;
			}
			$q .= "shipping_rate_weight_start <= '" . $d["weight"] . "'AND " ;
			$q .= "shipping_rate_weight_end >= '" . $d["weight"] . "'" ;
			$q .= " ORDER BY shipping_rate_list_order ASC,  shipping_rate_name" ;
			$dbr->query( $q ) ;*/

           break;


         }
      }

   }

  /*   function ShowShippingDetails($shippingmethods, $shippingdetails)
  {
    echo "<table border=1>";
      echo "<tr>";
        echo "<td> Type </td> <td> Cost </td> <td> Handling </td>";
      echo "</tr>";
    
    foreach($shippingmethods as $method)
    {                     
        echo "<tr>";
          echo "<td>" . $method . "</td>";
          echo "<td> " . $shippingdetails[$method]["cost"] . "</td>";
          echo "<td> " . $shippingdetails[$method]["handling"] . "</td>";
        echo "<tr>";       
    }
    
    echo "</table>";
  }   */




   
exit;

?>
